# Клиент игры "Здесь должно быть название, но мы его ещё не придумали"

### Состав команды: 
* Архипов Иван
* Батманов Игорь
* Боков Аркадий
* Кологерманский Егор

Игра была спроектирована в жанре тактической-rpg пошаговой стратегии. На данный момент готовится реализация первого (и основного) сценария игры: свободного сражения между двумя игроками. Сражение представляет собой последовательные действия игроков над их юнитами (предварительно выбранными) на поле из шестиугольников. За основу была взята (но существенно изменена) механика боёв игры Heroes of Might & Magic III.

На данный момент в "Свободном сражении" доступно 3 расы, из которых игроку предлагается выбор - Люди, Восставшие из мёртвых и Warcraft (тестовая раса). Для каждой расы существует свой уникальный набор юнитов и их веток развития. В более-менее полной мере реализованы юниты только расы Людей (для этой расы прописано уже более 60 классов). Раса Мёртвых требует доработки.

В master находится первая стабильная тестовая версия программы, позволяющая запустить её и пройти путь набора отряда для данного сценария. 

# Установка

### Windows:
* Скачать сборку, упакованную в .zip архив: http://files.gi1dor.ru/goosehouse-game.zip
* Распаковать всё содержимое архива в любую папку 
* Для запуска использовать файл client.exe

### Linux Debian-based (Debian ver. >= 8, Ubuntu ver. >= 16.04 LTS, etc.)
* Открыть терминал и последовательно выполнять команды:

```bash
wget http://files.gi1dor.ru/goosehouse-game.deb
sudo apt-get -f install ./goosehouse-game.deb
rm goosehouse-game.deb
```

* Для запуска использовать консольную команду `goosehouse-game`

* В случае, если установка через apt-get -f install не удалась, выполните следующие действия вместо этой команды:

```bash
sudo apt-get install qt5-default qt5-image-formats-plugins qt5-style-plugins
dpkg -i ./goosehouse-game.deb
```


## Структура папок проекта:

#### Папка *assets* : 
В этой папке содержатся все графические файлы, связанные с проектом. Часть из них (версии для деплоя) собираются в специальные файлы ресурсов для каждой сцены, которые загружаются вместе со сценой.

#### Папка *include* :
Эта папка содержит в себе все .h файлы приложения - все интерфейсы классов приложения (исключения - .h файлы, связанные с .ui сценами, они хранятся вместе с этими сценами)

#### Папка *source* :
Здесь находятся все файлы реализации классов приложения, кроме тех, что завязаны на .ui файлах (аналогично с .h файлами, последние хранятся вместе с .ui сценами)

#### Папка *ui* : 
В папке ui размещены все файлы графических сцен проекта. Каждая сцена состоит из 3-х файлов - .ui, .cpp и .h. Одна логическая сцена (главное меню, к примеру), может состоять из нескольких физических, которые накладываются друг на друга (сцена анимированного фона, сцена меню, расположенного по центру)

#### Папка *res* :
В ней находятся специальные файлы .qrc, содержащие информацию о тех файлах из */аssets*, которые будут собраны в файл ресурсов.